const byte buttonPin=4;
//Setup LCD screen
#include <LiquidCrystal.h>
int rs=7;
int en=8;
int d4=9;
int d5=10;
int d6=11;
int d7=12;
LiquidCrystal lcd(rs,en,d4,d5,d6,d7);
//Declare calculation variables, I used doubles but could potentially use floats
double startTime;
double endTime;
double totalTime;
double avgTotalTime;
double bucket= 0;
double numThrows=3;
double currentEndTime;
double passingTime;
double heightMeters;
double heightFeet;
//Declare calculation constants
const double gravityMetric= 9.81;
const double gravityFeet= 32.3;
//Declare program neccesary objects
int program =0;
int selectProg=1;
String method ="Drop";
void setup() {
  // put your setup code here, to run once:
Serial.begin(9600);
pinMode(buttonPin, INPUT);
lcd.begin(16,2);
}

void loop() {
  // put your main code here, to run repeatedly:
switch(program){
  case(0)://Pick Method Drop Or Throw.
    //Intructions
    lcd.setCursor(0,0);
    lcd.print("Press button to ");
    lcd.setCursor(0,1);
    lcd.print("cycle options.");
    delay(2000);
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Hold to select ");
    lcd.setCursor(0,1);
    lcd.print("your option.");
    delay(2000);
    lcd.clear();
   //Print options on LCD Screen while loop allows top line to stay unaltered
   while (true){
    lcd.setCursor(0,0);
    lcd.print("Drop or Throw?");
    while (digitalRead(buttonPin)==1){
    }
      lcd.setCursor(0,1);
      lcd.print("     ");
      lcd.setCursor(0,1);
      lcd.print(method);
      if (digitalRead(buttonPin)==0){ 
        if (selectProg==1){
          //program=2;
          method= "Throw";
          selectProg=2;
          
          }
        else if (selectProg==2){
          
          //program =3;
          method= "Drop";
          selectProg=1;
          
          }
      }
      delay(500);
      if(digitalRead(buttonPin)==0){
        program=1;
        lcd.clear();
        break;
        
       }
    }
    break;
   
   case(1)://Instructions for each Method and Arduino selecting proper program 
      lcd.setCursor(0,0);
      lcd.print("You've Selected");
      lcd.setCursor(0,1);
      lcd.print(method);
      delay(2000);
      lcd.clear();
                           
      if (method== "Drop"){
          lcd.setCursor(0,0);
          lcd.print("Push and hold ");
          lcd.setCursor(0,1);
          lcd.print("the button until");
          delay(2000);
          lcd.clear();
          lcd.setCursor(0,0);
          lcd.print("hits the ground");
          lcd.setCursor(0,1);
          lcd.print("I'll do the Rest.");
          
      }
      if (method== "Throw"){
          lcd.setCursor(0,0);
          lcd.print("Push and hold ");
          lcd.setCursor(0,1);
          lcd.print("the button until");
          delay(3000);
          lcd.clear();
          lcd.setCursor(0,0);
          lcd.print("you catch object");
          lcd.setCursor(0,1);
          lcd.print("Repeat 3 times");
          delay(2000);
         
      }
      if(selectProg==2){
        program=3;
        
      }
      if(selectProg==1){
        program=2;
      }
      break;

   case(2)://Drop Program
      delay(5000);
      lcd.clear();
      lcd.setCursor(0,0);
      lcd.print("Ready to Drop...");
      //Start Stopwatch
      while (digitalRead(buttonPin)==1){
      }
      if (digitalRead(buttonPin)==0){
        startTime=millis();
      }
      //Display time passing
      while (digitalRead(buttonPin)==0){
          currentEndTime=millis();
          passingTime = (currentEndTime - startTime)/1000.;
          lcd.setCursor(0,1);
          lcd.print(passingTime);
          lcd.setCursor(6,1);
          lcd.print("Sec");
          delay(10);
      }
      //Stop Stopwatch and Calculate total time
      while (digitalRead(buttonPin)==1){
          lcd.setCursor(11,1);
          lcd.print("Stop");
          endTime=millis();
          totalTime = (endTime - startTime)/1000;
          delay (1000);
          lcd.clear();
          lcd.setCursor(0,0);
          lcd.print("Total air time = ");
          lcd.setCursor(0,1);
          lcd.print(totalTime);
          lcd.setCursor(6,1);
          lcd.print(" Seconds");
          delay(3000);
          //Uses Newtonian Kinematics[height= (1/2)*acceleration*time^2] to solve for height
          heightMeters=(1./2.)*gravityMetric*totalTime*totalTime;
          heightFeet=(1./2.)*gravityFeet*totalTime*totalTime;
          lcd.clear();
          lcd.setCursor(0,0);
          lcd.print("Height= ");
          lcd.setCursor(0,1);
          lcd.print(heightFeet);
          lcd.setCursor(6,1);
          lcd.print("ft");
          lcd.setCursor(9,1);
          lcd.print(heightMeters);
          lcd.setCursor(15,1);
          lcd.print("m");      
          delay(7000);
          break;
      }
      //Back to start Screen
      reset();
    break;
   case(3)://Throw Program
     delay(5000);
     avgThrowTime();// Custom Function to get avg airtime of the three throws
     //Uses Newtonian Kinematics[height= (1/2)*acceleration*time^2] to solve for height
     //In this case time is cut in half because we solve for max height where Velocity=0 (y-direction)
     heightMeters=(1./2.)*gravityMetric*((avgTotalTime*avgTotalTime)/4.);
     heightFeet=(1./2.)*gravityFeet*((avgTotalTime*avgTotalTime/4.));
     // The time is divided by 4 because at half (1/2) the total air time is when the projectile 
     // reaches it's max height, and the time in Newtons equation is squared so (1/2)^2=(1/4)=dividing by 4
     lcd.clear();
     lcd.setCursor(0,0);
     lcd.print("Max Height= ");
     lcd.setCursor(0,1);
     lcd.print(heightFeet);
     lcd.setCursor(6,1);
     lcd.print("ft");
     lcd.setCursor(9,1);
     lcd.print(heightMeters);
     lcd.setCursor(15,1);
     lcd.print("m");      
     delay(7000); 
     //Back to Start Screen
      reset();
     break;
  }  
}
//Custom function referenced above
void avgThrowTime (){
  //for loop to allow getting average
  for (int j=1; j<=numThrows; j++){
      lcd.clear();
      lcd.setCursor(0,0);
      lcd.print("Ready to Drop");
      lcd.setCursor(15,0);
      lcd.print(j);
      //Start StopWatch
      while (digitalRead(buttonPin)==1){
      }
      if (digitalRead(buttonPin)==0){
        startTime=millis();
      }
      //Stop Stopwatch and calculate total time
      while (digitalRead(buttonPin)==0){
          currentEndTime=millis();
          passingTime = (currentEndTime - startTime)/1000.;
          lcd.setCursor(0,1);
          lcd.print(passingTime);
          lcd.setCursor(6,1);
          lcd.print("Sec");
          delay(10);
      }
      while (digitalRead(buttonPin)==1){
          lcd.setCursor(11,1);
          lcd.print("Stop");
          endTime=millis();
          totalTime = (endTime - startTime)/1000;
          delay (1000);
          lcd.clear();
          lcd.setCursor(0,0);
          lcd.print("Total air time = ");
          lcd.setCursor(0,1);
          lcd.print(totalTime);
          lcd.setCursor(6,1);
          lcd.print(" Seconds");
          delay(2000);
          bucket= bucket+totalTime;
          break;
          
     }
     avgTotalTime=bucket/numThrows;
   }
}
//Reset function for after completion of each propgram
void reset (){
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Reseting...");
  program=0;
  method= "Drop";
  bucket= 0;
  selectProg=1;
  delay (750); 
}
